#!/bin/bash

maxcounter=30
counter=1
echo "Waiting for mysql init..."
check_connection_cmnd="flyway -url=jdbc:mysql://db -schemas=ml -user=root -password=${MYSQL_PSW} info 1>/dev/null 2>/dev/null"
eval $check_connection_cmnd
# while return code is non zero (error) - should try connecting
while [ $? != 0 ]; do
    sleep 1
    counter=`expr $counter + 1`
    if [ $counter -gt $maxcounter ]; then
        >&2 echo "We have been waiting for MySQL too long already; failing."
        exit 1
    fi;
    eval $check_connection_cmnd
done
# if connection is ok - start migration
if [ $? == 0 ]; then
    flyway -url=jdbc:mysql://db?maxAllowedPacket=33554432 -schemas=ml -user=root -password=${MYSQL_PSW} migrate;
fi;